// Configure the framework
#include "SoulissFramework.h"

// Configure the framework
#include "bconf/StandardArduino.h" // Use a standard Arduino
#include "conf/ethW5100.h"  
//#include "conf/IPBroadcast.h"


#include <SPI.h>
#include "Souliss.h"

uint8_t ip_address[4]  = {192, 168, 27, 78};
uint8_t subnet_mask[4] = {255, 255, 255, 0};
uint8_t ip_gateway[4]  = {192, 168, 27, 1};
#define myvNet_address  ip_address[3]       // The last byte of the IP address (77) is also the vNet address
#define Gateway_address 77
#define Peer_address    78
#define Peer_address    79

#define RelaySiren  0
#define RelayPIR  1
#define Relay1_3  2
#define Relay1_4  3
#define Alarm_Armed 5
#define Alarm_Active 6
#define PIR1_1 7
#define PIR1_2 8

#define PIR1_1_on     0xFF01,0x01
#define PIR1_1_off    0xFF01,0x02
#define PIR1_2_on     0xFF02,0x01
#define PIR1_2_off    0xFF02,0x02
#define Alarm_on      0xFF03,0x01
#define Alarm_off     0xFF03,0x02
#define Alarm_sirenON   0xFF04,0x01
#define Alarm_sirenOFF   0xFF04,0x02
#define PIRpower_on   0xFF05, 0x01
#define PIRpower_off   0xFF05, 0x02



void setup()
{   
    Serial.begin(57600);
    Initialize();
    Serial.flush();
    Souliss_SetIPAddress(ip_address, subnet_mask, ip_gateway);

    Set_T11(RelaySiren);
    Set_T11(RelayPIR);
    Set_T11(Relay1_3);
    Set_T11(Relay1_4);

    Set_T11(Alarm_Armed);
    Set_T11(Alarm_Active);
    
    Set_T11(PIR1_1);
    Set_T11(PIR1_2);

    
    pinMode(A0, OUTPUT); // Power the LED
    pinMode(A1, OUTPUT); // Power the LED
    pinMode(A2, OUTPUT); // Power the LED
    pinMode(A3, OUTPUT); // Power the LED
    
    pinMode(6, INPUT); // Power the LED
    pinMode(7, INPUT); // Power the LED
}

void loop()

{   
    // Here we start to play
    EXECUTEFAST() {                     
        UPDATEFAST();   

        // Read every 510ms the input state and send it to the other board  
        FAST_510ms() {

      DigIn2State(6, Souliss_T1n_OnCmd, Souliss_T1n_OffCmd, PIR1_1); 
      DigIn2State(7, Souliss_T1n_OnCmd, Souliss_T1n_OffCmd, PIR1_2); 
      if (mOutput(PIR1_1) == 1)
      pblsh(PIR1_1_on);
      if (mOutput(PIR1_1) == 0)
      pblsh(PIR1_1_off);
      if (mOutput(PIR1_2) == 1)
      pblsh(PIR1_2_on);
      if (mOutput(PIR1_2) == 0)
      pblsh(PIR1_2_off);

      Logic_T11(PIR1_1);
      Logic_T11(PIR1_2);
      
      
        } 
 FAST_1110ms() {
          Logic_T11(RelaySiren);
          
          Logic_T11(Relay1_3);
          Logic_T11(Relay1_4);

          if(sbscrb(Alarm_on)){
          mInput(Alarm_Armed) = Souliss_T1n_OnCmd;
          Logic_T11(Alarm_Armed);
          }

          if(sbscrb(Alarm_off)){
          mInput(Alarm_Armed) = Souliss_T1n_OffCmd;
          Logic_T11(Alarm_Armed);
          }

          if(sbscrb(Alarm_sirenON)){
          mInput(Alarm_Active) = Souliss_T1n_OnCmd;
          Logic_T11(Alarm_Active);
          }

          if(sbscrb(Alarm_sirenOFF)){
          mInput(Alarm_Active) = Souliss_T1n_OffCmd;
          Logic_T11(Alarm_Active);
          }

          if(sbscrb(PIRpower_on)){
          mInput(RelayPIR) = Souliss_T1n_OnCmd;
          Logic_T11(RelayPIR);
          } 

          if(sbscrb(PIRpower_off)){
          mInput(RelayPIR) = Souliss_T1n_OffCmd;
          Logic_T11(RelayPIR);
          } 
   
            }
        
        
        // Here we handle here the communication with Android, commands and notification
        // are automatically assigned to MYLEDLOGIC
        FAST_PeerComms();     
                        
    }
     EXECUTESLOW() {
        UPDATESLOW();

        SLOW_10s() {        // We handle the light timer with a 10 seconds base time
            //Timer_SimpleLight(MYLIGHT);                 
        }       
    }       
} 

